
// Matt Streeter
// 2/27/00
// ESSTATIC.H
// Header for class TESStatic; custom implementation of TStatic control
// Copyright Matt Streeter, 2000.  All rights reserved

#ifndef __ESSTATIC_H__
#define __ESSTATIC_H__

#include "eswindow.h"

// Set to 1 to enable use of custom implementation of TStatic; otherwise
// default implementation will be used.
#define USE_ES_STATICS 1

#if(!USE_ES_STATICS)
#include <owl\static.h>
class TESStatic: public TStatic
{
  public:
	TESStatic(TWindow* parent, int id, const char far* title, int x, int y,
		int w, int h, uint textLen = 0, TModule* module = 0);
};
#else
class TESStatic: public TWindow
{
  public:
	TESStatic(TESWindow* parent, int, const char far* title, int x, int y,
		int w, int h, uint = 0, TModule* = 0);
	void SetText(const char far* str);
	int GetText(char far* str, int maxChars);
	int GetTextLen();
	void EvMouseMove(uint modKeys, TPoint& point);

	DECLARE_RESPONSE_TABLE(TESStatic);

  protected:
  	void GetWindowClass(WNDCLASS& WndClass);
	void Paint(TDC&, bool, TRect&);

  private:
	TESWindow *mpESParent;
};
#endif

#endif // __ESSTATIC_H__
