
// Matt Streeter
// 2/27/00
// GENWIN.H
// Header for class TGenerationWindow; window class for displaying networks
// in a population by generation.
// Copyright Matt Streeter, 2000.  All rights reserved

#ifndef __GENWIN_H__
#define __GENWIN_H__

#include "heredity.h"

class TGenerationWindow: public THeredityWindow
{
  public:
	TGenerationWindow(TWindow *pParent,char *pTitle,
		TGeneration *pGenerationList,Network *pNetwork,double dMaxWeight,
		Parameter *pParam);
	void Paint(TDC&, bool, TRect&);

   static TColor mLabelColor;
  protected:
	TScroller *mpScroller;
	int miMaxTreeDepth;

	void EvLButtonDown(uint, TPoint& point);
	void EvLButtonDblClk(uint, TPoint& point);
	void DrawParentLinks(int iNetwork,byte bErase,int iDepth=0);
	void EvSize(UINT SizeType, TSize& Size);

	DECLARE_RESPONSE_TABLE(TGenerationWindow);
};

#endif // __GENWIN_H__