
// Matt Streeter
// 2/27/00
// MATRIX.H
// Header for class TMatrixView, providing compact matrix display of networks.
// Copyright Matt Streeter, 2000.  All rights reserved

#ifndef __MATRIX_H__
#define __MATRIX_H__

#include "network.h"
#include <owl\dc.h>

class TMatrixView
{
  public:
	TMatrixView(Network *pNetwork,int iPixelsPerSquare,double dMaxWeight);
	void Paint(TDC& dc,int iXPos,int iYPos,Chromosome *pChromosome);
	int SetPixelsPerSquare(int iPixelsPerSquare);
	int GetHeight();
	int GetWidth();
	int GetVSpacing();
	int GetHSpacing();
   int GetPixelsPerSquare() {return miPixelsPerSquare;}

  protected:
	Network *mpNetwork;
	int miHeight,miWidth;
	int miPixelsPerSquare;
	double mdMaxWeight;

	int CalculateSize();
};

#endif // __MATRIX_H__
