
// Matt Streeter
// 2/27/00
// TREE.H
// Header for class TFamilyTreeWindow; window class for display of network's
// "family tree".
// Copyright Matt Streeter, 2000.  All rights reserved

#ifndef __TREE_H__
#define __TREE_H__

#include "eswindow.h"
#include "heredity.h"

class TFamilyTreeWindow: public THeredityWindow
{
  public:
	TFamilyTreeWindow(TWindow *pParent,char *pTitle,
		TGeneration *pGenerationList,Chromosome *pSelectedNetwork,
		Network *pNetwork,double dMaxWeight,Parameter *pParam);
	void Paint(TDC&, bool, TRect&);
	void EvSize(UINT SizeType, TSize& Size);
   int DrawTree(TDC& dc,TRect& DrawRect);
	int DrawTreeLayer(TDC& dc,Chromosome *pChromosome,
		int x,int y,int iWidth,int iDrawDepth,int iCurDepth=0);
	Chromosome *TFamilyTreeWindow::FindNetwork(int iGeneration,int iIndex);

  protected:
	Chromosome *mpSelectedNetwork;

	DECLARE_RESPONSE_TABLE(TFamilyTreeWindow);
};

void GetFamilyTreeTitle(char *pTitle,Chromosome *pChromosome);

#endif